#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>

extern struct in_addr *parse_resolv(int *);

int write_firewall(int policy, int ether, int ether1, int *ports, int nump)
{

	int i;
	FILE *fw=fopen("/tmp/check", "w");
	int num;
	struct in_addr *p;
	
	for(i=0;i<nump;i++)
	{
		fprintf(fw, "ipfwadm -I -i accept -S 0/0 -D 0/0 %d -P tcp -y\n",
			ports[i]);
	}
	
	fprintf(fw, "ipfwadm -I -i accept -S 0/0 -D 0/0 -W lo\n");
	
	if(ether==0)
		fprintf(fw, "ipfwadm -I -i accept -S 0/0 -D 0/0 -W eth0\n");
	if(ether1==0)
		fprintf(fw, "ipfwadm -I -i accept -S 0/0 -D 0/0 -W eth1\n");

	if(policy==0)
	{
		p=parse_resolv(&num);
		for(i=0;i<num;i++)
		{
			fprintf(fw, "ipfwadm -I -i accept -S %s/53 -D 0/0 -P udp\n",
				inet_ntoa(p[i]));
		}
		fprintf(fw, "ipfwadm -I -i deny -S 0/0 -D 0/0 -P tcp -y\n");
		fprintf(fw, "ipfwadm -I -i deny -S 0/0 -D 0/0 -P udp\n");
	}
	else
	{
		fprintf(fw, "ipfwadm -I -i deny -S 0/0 -D 0/0 0-1023 2049 -P tcp -y\n");
		fprintf(fw, "ipfwadm -I -i deny -S 0/0 -D 0/0 0-1023 2049 -P udp\n");
		fprintf(fw, "ipfwadm -I -i deny -S 0/0 -D 0/0 6000-6009 -P tcp -y\n");
	}
	fclose(fw);
}

